      SUBROUTINE WH04F1 (IM,K)
C     THIS SUBROUTINE WAS CHANGED ON FEB 10, 2000 TO CHANGE THE
C     DIFFERENCE CRITERION OF 5 FOR "iso' TEMPERATURE REGIMES TO
C     6.
C
C FILLING SLOTS WITH LIGHT PRECIPITATION
C
C     IM IS NR OF MONTH,AND K IS NUMBER OF PREVIOUS MOIST.COND.
C
      INTEGER DP(64), PMC, DMC(3), DPMC, I3, KK, NR, IGMC
      REAL DR(64), CNPE, FSL, ESL, RPE, RPD
      REAL MP(12), SL(64), NPE, LP, MPE(12)
      LOGICAL * 2 MSW, C(3)
C
      COMMON /WHMM/  MP,MPE,SL,FSL,C
C
      DATA DP /8,7,16,6,15,24,5,14,23,32,4,13,22,31,40,3,12,
     1  21,30,39,48,2,11,20,29,38,47,56,1,10,19,28,37,46,55,64,9,18,
     2  27,36,45,54,63,17,26,35,44,53,62,25,34,43,52,61,33,42,51,60,
     3  41,50,59,49,58,57/
      DATA DR /1.,1.,1.,1.,1.02,1.03,1.05,1.07,1.09,1.11,1.13,1.15,
     1  1.17,1.19,1.21,1.23,1.26,1.28,1.31,1.34,1.37,1.40,1.43,1.46,
     2  1.49,1.53,1.57,1.61,1.65,1.69,1.74,1.78,1.84,1.89,1.95,2.01,
     3  2.07,2.14,2.22,2.30,2.38,2.47,2.57,2.68,2.80,2.93,3.07,3.22,
     4  3.39,3.58,3.80,4.03,4.31,4.62,4.98,9*5./
C
C  INITIALIZE
      DO 10 I = 1,3
         DMC(I) = 0
   10    C(I) = .FALSE.
      MSW = .FALSE.
      DPMC = 0
C
C  FIXING PREVIOUS MOISTURE CONDITION (PMC),BY K(ARGUMENT)
C
      PMC = K
C
C  CALCULATE MONTHLY AMOUNTS(LP,NPE)FOR MONTH IM
C
      LP = MP(IM)/2.
      NPE = (LP-MPE(IM))/2.
C
C  TESTING SIGN OF NPE
C
C
C  FIXING NPE (NET POT.EYAP.)
C
      IF (NPE.LT.0.) THEN
         NPE = -NPE
         CNPE = NPE
        ELSEIF (NPE.EQ.0.) THEN
         GO TO 90
        ELSE
         MSW = .TRUE.
         CNPE = NPE
        ENDIF
C
C  PROCESS SLOTS
C
   30 DO 80 I3=1,64
         IF (.NOT.MSW) GO TO 60
         IF (NPE.LE.0.) GO TO 90
C
C  FILLING OF THE SLOTS
C
         IF (SL(I3).GE.FSL) GOTO 80
C
C   DEFINE EMPTY SPACE (ESL),FILL IT,REDUCE NPE
C
         ESL = FSL - SL(I3)
         IF (ESL.GE.NPE) GOTO 40
         SL(I3) = FSL
         NPE = NPE - ESL
         GOTO 50
   40    SL(I3) = SL(I3) + NPE
C
         NPE = 0.
C
C   CALCULATE PE NEEDED TO CHANGE MC
C
C      DEFINE MOISTURE CONDITION AT PRESENT
C
   50    CALL WH04F3(KK)
C
C
C COMPARE PRESENT (AMC)AND PAST(PMC)
C
         IF (KK.EQ.PMC) GO TO 80
C
C MAKE SUM OF PE REQUIRED TO MAKE CHANGE
C
         IF(NPE.LE.0.) GO TO 90
         RPE = CNPE - NPE
C
         DMC(K) = INT(15.*RPE/CNPE)-DPMC
         IGMC = DMC(K)
         DPMC = DMC(K)+DPMC
         DMC(K) = 0
         CALL WH04F4 (K,IGMC)
         PMC = KK
         K = KK
         GO TO 80
C
C
C  DEPLETION OF SLOTS
C
   60    IF (NPE.LE.0.) GO TO 90
         NR = DP(I3)
C
C   TESTING IF SLOT IS EMPTY
C
         IF (SL(NR).LE.0.) GO TO 80
C
C   TAKING WATER OUT  (RPD=REQUIRED PE)
C
         RPD = SL(NR) * DR(I3)
         IF (NPE.LE.RPD) GO TO 70
         SL(NR) = 0.
         NPE = NPE-RPD
         GOTO 50
C
C   LAST REDUCTION
C
   70    SL(NR) = SL(NR) - (NPE/DR(I3))
         NPE=0.
         GO TO 50
   80    CONTINUE
C
   90 DMC(K) = 15-DPMC
      IGMC = DMC(K)
      DMC(K)=0
      CALL WH04F4 (K,IGMC)
C
      RETURN
      END
C
C
      SUBROUTINE WH04F2 (I)
C
C FILLING SOIL WITH HEAVY PRECIPITATION
C
      REAL MP(12),MPE(12),SL(64),FSL,ESL,HP
      LOGICAL * 2  C(3)
      INTEGER I3, I
C
      COMMON /WHMM/  MP,MPE,SL,FSL,C
C
      HP=MP(I)/2.
      DO 20 I3=1,64
         IF (SL(I3).GE.FSL) GOTO 20
         ESL=FSL-SL(I3)
         IF (ESL.GE.HP) GOTO 10
         SL(I3)=FSL
         HP=HP-ESL
         GOTO 20
   10    SL(I3)=SL(I3)+HP
         GOTO 30
   20    CONTINUE
   30 RETURN
      END
C
C
      SUBROUTINE WH04F3 (K)
C
C EVALUATE MOISTURE CONDITION
C
      REAL SL(64),MP(12),MPE(12),FSL
      INTEGER K,I
      LOGICAL * 2 C(3),PC(6)
      COMMON /WHMM/ MP,MPE,SL,FSL,C
C
      DO 2 I=1,3
    2    C(I)=.FALSE.
      DO 4 I=1,6
    4    PC(I)=.FALSE.
      PC(1)=SL( 9).LE.0.
      PC(2)=SL(17).LE.0.
      PC(3)=SL(25).LE.0.
      C(1)=PC(1).AND.PC(2).AND.PC(3)
      C(2)=(.NOT.C(1)).AND.(PC(1).OR.PC(2).OR.PC(3))
      PC(4)=SL( 9).GT.0.
      PC(5)=SL(17).GT.0.
      PC(6)=SL(25).GT.0.
      C(3)=PC(4).AND.PC(5).AND.PC(6)
C
C DEFINING MOISTURE CONDITION
C
      DO 6 I=1,3
      IF (.NOT.C(I)) GOTO 6
      K=I
      GOTO 8
    6 CONTINUE
    8 RETURN
      END
C
C
      SUBROUTINE WH04F4 (K,N)
C
C STORING OF DAYS DURING ONE  YEAR
C
      INTEGER ND(3),K,IB,IE,N
      INTEGER*2 IDAY(360)
      COMMON /WHBA/ IDAY,ND,IB,IE
C
C COMMON SHOULD BE SHARED BY MAIN,F1,F2,F3
C
C IDAY,IE,ND, IB SHOULD BE SET TO 0 ,1 IN MAIN PROGRAM
      IE=IE+N
      DO 25 I=IB,IE
   25    IDAY(I)=K
      IB=IE+1
      ND(K)=ND(K)+N
      RETURN
      END
C
C
      SUBROUTINE WH04F5 (IB,IR,X,MAX,IDAY,SWM)
C
C  SWM INDICATES IF MC(X) HAS TO BE ACCOUNTED FOR
C    WHEN SWM IS TRUE SEQUENCE OF MC(X) IS COUNTED
C    IF SWM=.FALSE.,THE MC(.NOT.X) IS COUNTED.
C
C  IB IS BEGINNING DAY,IR IS DURATION OF CHECKING ,X IS NR OF MC
C
C
      INTEGER ND(3),X,IZ,IB,IR,N,N1,MAX,IFIN
      INTEGER*2 IDAY(360)
      LOGICAL*2 SW,SWM
C
C  INITIALIZE
C
      ND(X)=0
      MAX=0
      IFIN =0
      SW=.FALSE.
C
C  FIX PERIOD OF COUNTING
C
      IZ=IB+IR-1
C
C PROCEED
C
      DO 65 N=IB,IZ
      N1=N+1
      IF (N1.GT.360) N1=N1-360
      IF (N.GT.360) THEN
         I=N-360
        ELSE
         I=N
        ENDIF
      IF (SWM) GO TO 30
      IF (IDAY(I).NE.X) GOTO 25
      GO TO 65
   25 IF (IDAY(N1).EQ.X) GOTO 45
      GO TO 40
   30 IF (IDAY(I).EQ.X) GOTO 35
      GO TO 65
   35 IF (IDAY(I).NE.IDAY(N1)) GOTO 45
   40 ND(X)=ND(X)+1
      SW=.TRUE.
      GOTO 65
   45 IF (SW) GOTO 50
      GOTO 65
   50 ND(X)=ND(X)+1
      IF (ND(X).GT.MAX) GOTO 60
   55 ND(X)=0
      SW=.FALSE.
      GOTO 65
   60 MAX=ND(X)
      GOTO 55
   65 CONTINUE
      IF (SW) IFIN=ND(X)
      IF (IFIN.GT.MAX) MAX=IFIN
      RETURN
      END
C
C
      SUBROUTINE WH04F6(LT5C,LT8C,NSD,NCPM,M,N,CT,ND,SWT,CD,AST,D,ANS)
C
C  DEFINITION OF MOISTURE REGIMES
C
      INTEGER NSD(3),NCPM(2),ND(3),M,N,LT5C,LT8C,I
      CHARACTER*8 NMRE(6),ANS
      LOGICAL*2 SWM,SWP
      LOGICAL*2 CT(10),SWT,CD(5),CMR(25),CM(4)
      COMMON /WHCC/ CM,CMR,SWP
C
      DATA NMRE /' ARIDIC ',' XERIC  ',' USTIC  ','  UDIC  ',
     1'PERUDIC ','UNDEFIN.'/
C
C  INITIALIZE
C
      DO 10 I=1,4
   10    CM(I)=.FALSE.
      DO 20 I=1,25
   20    CMR(I)=.FALSE.
C
C  PERUDIC
C
      IF (SWP) GO TO 30
      IF (SWT) GO TO 80
C
C  ARIDIC
C
  30  CMR(1)=(LT5C.GT.0).AND.(LT8C.GT.0)
      CM(1)=NSD(1).GT.(LT5C/2)
      CM(2)=NCPM(2).LT.90
      CMR(2)=CM(1).AND.CM(2)
      CD(1)=CMR(1).AND.CMR(2)
C
C  XERIC
C
      CMR(3)=M.GE.45
      CMR(4)=N.GE.45
      CMR(5)=CMR(3).AND.CMR(4)
      CM(3)=AST.LT.22.
C
C  THE 5 DEGREES DIFFERENCE FOR XERIC CHANGED TO 6 ON FEB 10, 2000
C
      CM(4)=D.GE.6.
      CMR(6)=CM(3).AND.CM(4)
      CD(2)=(.NOT.CD(1)).AND.CMR(5).AND.CMR(6)
C
C  USTIC
C
      CMR(7)=(.NOT.CT( 1)).AND.(.NOT.CT( 2))
      CMR(8)=AST.GE.22.
C
C  THE 5 DEGREES DIFFERENCE CHANGED TO 6 ON FEB 10, 2000
C
      CMR(9)= D  .LT.6.
      CMR(10)=CMR(8).OR .CMR(9)
      CMR(11)=(360-ND(3)).GE.90
      CMR(12)=CMR(10).AND.CMR(11)
      CMR(13)=(360-ND(1)).GT.180
      CMR(14)=NCPM(2).GE.90
      CMR(15)=CMR(13).OR.CMR(14)
      CMR(16)=CMR(12).AND.CMR(15)
C
      CMR(17)=NSD(1).LE.(LT5C/2)
      CMR(18)=.NOT.CMR(5)
      CMR(19)=CMR(6).AND.CMR(11).AND.CMR(17).AND.CMR(18)
      CMR(25)=CMR(6).AND.CMR(11).AND.(.NOT.CMR(17)).AND.(NCPM(2).GE.90).
     1AND.CMR(18)
      CMR(20)=CMR(16).OR.CMR(19).OR.CMR(25)
      CD(3)= CMR(7).AND.CMR(20)
C
C  UDIC
C
      CMR(21)=(360-ND(3)).LT.90
C
C  THE 5 DEGREES DIFFERENCE CHANGED TO 6 ON FEB 10, 2000
C
      CMR(22)=(AST.LT.22.).AND.(D.GT.6.)
      CMR(23)=CMR(22).AND.CMR(3)
      CMR(24)=.NOT.CMR(23)
      CD(4)=CMR(21).AND.CMR(24)
C
C  WRITE RESULTS
C
      IF (SWT) GO TO 80
      SWM=.FALSE.
      DO 60 JI=1,4
      IF (.NOT.CD(JI)) GO TO 60
      ANS=NMRE(JI)
      SWM=.TRUE.
   60 CONTINUE
      IF (SWM) GO TO 100
   70 ANS=NMRE(6)
      GO TO 100
   80 ANS=NMRE(5)
  100 RETURN
      END
C
C
      SUBROUTINE WH04F7 (JB,JR,NSD)
C
      INTEGER NSD(3),JB,JR,JE,ND(3),IB,IE,L,J,K
      INTEGER *2 IDAY (360)
C
      COMMON /WHBA/ IDAY,ND,IB,IE
C
      DO 10 J=1,3
   10    NSD(J)=0
      JE=JB+JR-1
      DO 20 L=JB,JE
         J=L
         IF (J.GT.360) J=J-360
         K=IDAY(J)
   20    NSD(K)=NSD(K)+1
      RETURN
      END
C
C
      SUBROUTINE CUF8(ND,NCPM,NTSU,NTWI,NCCM,NCCD,PPRF,TRR,ANS)
C
      INTEGER ND(3),NCPM(2),NTSU(3),NTWI(3),NCCM,NCCD
      INTEGER NTTS,NTTW,NPTS,NPTW,NBU,NCSM,NCWM,NCSP,NCWP
      INTEGER I1,L,LL
      CHARACTER*4 PPRF,ITRO(1)
      CHARACTER*8 BLAN,REG(5),TRR,ANS
      CHARACTER*8 TUS(4),TYP(3),DYP(3),DIV,QUAL,XYP(4),AR(2)
      LOGICAL*2 CR(2),V,W(4),X(2),XX(3),UD(3),XR(4),XE(3)
C
      COMMON /WCF8/ DIV,QUAL,NCSM,NCWM,NTTS,NTTW,NCSP,NCWP,
     1              NPTS,NPTW
C
      DATA ITRO /' Iso'/
      DATA BLAN /'        '/
      DATA REG /' USTIC  ','  UDIC  ',' ARIDIC ',' XERIC  ',
     1'PERUDIC '/
      DATA TUS /'Tempust.','Tropust.','Tempudic','Tropudic'/
      DATA TYP /'  Aridic','   Typic','    Udic'/
      DATA DYP /'   Typic','     Dry','     Dry'/
      DATA XYP /'   Xeric','     Wet','   Typic','   Typic'/
      DATA AR  /' Extreme','    Weak'/
C
C     INITIALIZE CASE
C
      DO 5 II=1,2
         X(II)=.FALSE.
    5    CONTINUE
      DO 10 II=1,3
         XE(II)=.FALSE.
   10    XX(II)=.FALSE.
      DO 15 II=1,4
         XR(II)=.FALSE.
   15    W(II)=.FALSE.
      QUAL=BLAN
      DIV=BLAN
      NTTS=0
      NTTW=0
      NPTS=0
      NPTW=0
      NBU=0
      V=.FALSE.
C
C     DEFINE SUBDIVISIONS
C
C  PROCESS ARIDIC
      IF (ANS.EQ.REG(3)) GO TO 30
C  PROCESS XERIC
      IF (ANS.EQ.REG(4)) GO TO 35
C  PROCESS PERUDIC
      IF (ANS.EQ.REG(5)) GO TO 40
C  DEFINE XERIC PROPERTIES
      XE(1)=NCCM.GT.45
      XE(2)=NCCD.GT.45
      XE(3)=NCCD.GT.90
C  SUBDIVISIONS FOR TEMPUSTIC REGIMES
      XR(1)=XE(1).AND.XE(2)
      XR(2)=XE(1).AND.(.NOT.XE(2))
      XR(3)=(.NOT.XE(1)).AND.XE(2)
      XR(4)=(.NOT.XE(1)).AND.(.NOT.XE(2))
C
      CR(1)=ANS.EQ.REG(1)
      CR(2)=ANS.EQ.REG(2)
      IF ((.NOT.CR(1)).AND.(.NOT.CR(2))) GO TO 85
C DEFINE CONTUDIC
      IF (ND(3).EQ.360) GO TO 60
C SUBDIVISIONS FOR USTIC AND UDIC
      IF (ND(1).EQ.0) GO TO 20
      NTTS=NTSU(2)+NTSU(3)
      NTTW=NTWI(2)+NTWI(3)
      GO TO 25
   20 NPTS=NTSU(3)
      NPTW=NTWI(3)
C  BASED ON CUMULATIVE DAYS MOIST
   25 V=PPRF.EQ.ITRO(1)
      W(1)=CR(1).AND.(.NOT.V)
      W(2)=CR(1).AND.V
      W(3)=CR(2).AND.(.NOT.V)
      W(4)=CR(2).AND.V
C SUBDIVISIONS FOR TROPUSTIC
      XX(1)=NCPM(2).LT.180
       X(1)=NCPM(2).GE.180
       X(2)=NCPM(2).LT.270
      XX(2)=X(1).AND.X(2)
      XX(3)=NCPM(2).GE.270
C SUBDIVIDE UDIC REGIMES
      NBU=ND(1)+ND(2)
      UD(1)=NBU.LT.30
      UD(2)=NBU.GE.30.AND.NBU.LT.60
      UD(3)=NBU.GE.60
      GO TO 45
C SUBDIVIDE ARIDIC
   30 DIV=REG(3)
      QUAL=AR(2)
      IF (NCPM(2).LE.45) QUAL= TYP(2)
      IF (ND(1).EQ.360) QUAL=AR(1)
      GO TO 85
C  SUBDIVIDE XERIC
   35 DIV=REG(4)
      QUAL=TYP(2)
      IF (NCCD.GT.90) QUAL=DYP(3)
      GO TO 85
C  PROCESS PERUDIC REGIME
   40 DIV=REG(5)
      NCSM=180
      NCWM=180
      NCSP=180
      NCWP=180
      NTSU(3)=180
      NTWI(3)=180
      GO TO 85
C
C    PREPARE PRINTING OF SUBTYPES
C
   45 DO 50 L=1,4
      IF (.NOT.W(L)) GO TO 50
      DIV=TUS(L)
      GO TO 55
   50 CONTINUE
   55 IF (CR(1)) GO TO 65
      IF (UD(1)) DIV=REG(2)
      IF (UD(1)) QUAL=TYP(2)
      IF (UD(2).OR.UD(3)) QUAL=DYP(3)
      GO TO 85
   60 DIV=REG(2)
      QUAL=TYP(2)
      GO TO 85
   65 IF (W(1)) GO TO 75
      DO 70 LL=1,3
      IF (.NOT.XX(LL)) GO TO 70
      QUAL= TYP (LL)
      GO TO 85
   70 CONTINUE
      GO TO 85
   75 DO 80 L=1,4
      IF (.NOT.XR(L)) GO TO 80
      QUAL=XYP(L)
      GO TO 85
   80 CONTINUE
   85 RETURN
      END
