C     PROGRAM PROBPC
C         BY A. VAN WAMBEKE
C
C            WRITTEN APRIL 1990 FOR PROBABILITY NEWHALL
C            TRYING TO PUT THE MAINFRAME PROBABILITY NEWHALL ON PC'S;
C            REVISED MARCH 2000 AND DIF CRITERION CHANGED TO 6.
C            ADDED TITLE PAGE;
C            TO LINK WITH PRB6SUB1.FOR AND PRB6SUB2.FOR
C
C   DATA DEFINITIONS
C
      CHARACTER * 8 PREG(6),BBL,PRR,TRR,ANS,DIV,QUAL,TD
      CHARACTER * 14 FNAME1, FNAME2
      CHARACTER * 4 KOUN, IPRF(1), PPRF, BLAN, NMTH(12)
      CHARACTER * 1 NTD(360),H,HH(2),EW,ENGLMTRC,ORIG,ALT,ALT2,YA,ALT3
      CHARACTER * 16 NAME, BLNK, KCHK, WORD(30)
C
      REAL SL(64), MP(12), MPE(12), T(12), EL
      REAL FC, FCD, TMA, ST, WT, DIF, ARF, AEV, PRMO
C
      INTEGER RLA1, RLA2, RLO1, RLO2, LSTN(30)
      INTEGER ND(3), NSD(3), NCPM(2), NTSU(3), NTWI(3)
      INTEGER NBD(6),NED(6),NZD(3),NBD8(6),NED8(6)
      INTEGER*2 IDAY(360), TYE(30), IYE, ID, YE(2)
      INTEGER KF, KG, JP, IM, N, IT, I, IK
      INTEGER NTTS, NTTW, NPTS, NPTW, ID5C, ID8C
      INTEGER K, ICON, LT5C, LT8C, IE, IB, NCCD, NCCM
      INTEGER NP, NP8, NCSM, NCWM, NCSP, NCWP, IR, IC
C
      LOGICAL*2 C(3),MSW,CD(5),SN,CR(11),REG(10),SWT,CM(4)
      LOGICAL*2 TC,TU,SWP,LPRO(7),SWST,SWFI,CMR(25)
      LOGICAL*2 TH, PT(30,41),OPT(3)
C
      COMMON /WHMM/ MP,MPE,SL,FSL,C
      COMMON /WHBA/ IDAY,ND,IB,IE
      COMMON /WHCC/ CM,CMR,SWP
      COMMON /WCF8/ DIV,QUAL,NCSM,NCWM,NTTS,NTTW,NCSP,NCWP,
     1              NPTS,NPTW
C
      DATA PREG /'PERGELIC', 'CRYIC   ', 'FRIGID  ',
     *           'MESIC   ', 'THERMIC ', 'HYPERTH.'/
      DATA BBL  /'        '/
      DATA BLAN /'    '/
      DATA IPRF /' ISO'/
      DATA BLNK /'                '/
      DATA PROB/'PROB    '/
      DATA HH /'N', 'S'/
      DATA NMTH /' JAN',' FEB',' MAR',' APR',' MAY',' JUN',
     1' JUL',' AUG',' SEP',' OCT',' NOV',' DEC'/
      DATA YA/'Y'/
C
C  WRITE TITLE PAGE
C
      WRITE (*,99)
   99 FORMAT(/'         SOIL MOISTURE REGIME SIMULATION MODEL (NSM)',/
     1'                  by FRANKLIN NEWHALL (1972)',/
     2'             Fortran 77 version by A. Van Wambeke',/
     3'             Department of Crop and Soil Sciences',/
     4'                      Cornell University ',//)
C
C  ENTER DATE OF PROCESSING
C
      WRITE (*,2) '  Enter the date as MM/DD/YY : '
      READ (*,14) TD
   14 FORMAT (BN,A8)
C
C OPPORTUNITY TO CHANGE WTC, FC AND FCD.
C
   54 WRITE (*,74)
   74 FORMAT(/ '  The waterholding capacity (WTC) of the',/
     1'  profile is set at 200. mm; the soil',/
     2'  temperature in the model is 2.5 degrees (FC)',/
     3'  centigrades higher than the air temperature',/
     4'  and the seasonal amplitude reduced',/
     5'  by a factor 0.66 (FCD).',//
     6'  DO YOU WANT TO KEEP THESE CONSTANTS ?',/
     7'  TYPE Y OR N AND PRESS ENTER (use only capitals) :')
      READ(*,79)ALT
   79 FORMAT(BN,A1)
      IF(ALT.EQ.YA) GO TO 56
   67 WRITE(*,81)
   81 FORMAT(/'   ENTER YOUR CHOICES IN THE',/
     9'  SEQUENCE WTC, FC, FCD AS',/ 
     8'  IN THE EXAMPLE SHOWN BELOW:',/
     *'  200.,2.5,0.66 :')
      READ (*,*, ERR = 51) WTC, FC, FCD
      IF(FC.LE.0..OR.FCD.GT.1..OR.FCD.LE.0.)GO TO 51
      IF (WTC.LE.0.) GO TO 51
      GO TO 52
   51 WRITE (*,82)
   82 FORMAT( ' ERROR IN INPUT; REPEAT BELOW, NO BLANKS',/
     1' ALLOWED; USE ONLY COMMAS TO SEPARATE INPUTS; ',/
     2' DO NOT FORGET DECIMAL POINTS;',/
     3' TRY AGAIN ON THIS LINE :')
      GO TO 67
C
C  DEFAULT VALUES FOR WTC, TEMP. INCREASE AND SEASON REDUCTION
C
   56 WTC=200.
      FC=2.5
      FCD=0.66
C
C INPUT OF THE STATION DATA FROM FILE
C
   52 WRITE (*,2) '  Enter the input data file name: '
      READ (*,1) FNAME1
    1 FORMAT (BN,A14)
    2 FORMAT (1X,A\,//)
      OPEN (3, FILE = FNAME1, FORM = 'FORMATTED')
      WRITE (*,2) '  Enter the output data file name: '
      READ (*,1) FNAME2
      OPEN (8, FILE = FNAME2, FORM = 'FORMATTED', STATUS = 'NEW')
      OPEN (6, FILE = 'LPT1', FORM = 'FORMATTED')
C
C  TEMPORARY SCRATCH FILES
C
      OPEN (7, FILE = 'STORE.SCR', STATUS = 'NEW')
      OPEN (9, FILE = 'PROBA.SCR', STATUS = 'NEW')
C
C  OFFER PROCESSING ALTERNATIVES
C
C      DO 15 I = 1,3
C   15 OPT(I)=.TRUE.
   76 WRITE (*,78)
   78 FORMAT(//'   Do you want a printout of the moisture  ',/
     5'     calenders of each individual year?',//
     6'     ANSWER by entering Y or N: ')
      READ(*,86, ERR = 73)ALT2
   86 FORMAT(A1)
      GO TO 75
   73 WRITE (*,2) '  ERROR IN INPUT, REPEAT YOUR CHOICE'
      GO TO 76
C
C   INITIALIZE DATA
C
C
   75 CONTINUE
      FSL=WTC/64.
      DO 23 N=1,64
   23    SL(N)=0.
      NPR=0
      K=1
      SWP=.TRUE.
      DO 53 I=1,30
      WORD(I)=BLNK
      DO 53 J=1,41
   53 PT(I,J)=.FALSE.
      KCHK=BLNK
      SWST=.FALSE.
      SWFI=.FALSE.
C
C  INITIALIZE PROCESSING OF A STATION
C
  100 DO 27 I=1,11
   27 CR(I)=.FALSE.
      DO 28 I=1,10
   28 REG(I)=.FALSE.
      DO 30 I=1,5
   30 CD(I)=.FALSE.
      MSW=.TRUE.
      SWT=.FALSE.
      TC=.FALSE.
C
      ANS=BBL
      PRR=BBL
      TRR=BBL
      PPRF=BLAN
C
      DO 29 N=1,3
         NTWI(N)=0
         NTSU(N)=0
         NSD(N)=0
         NZD(N)=0
         ND(N)=0
   29 C(N)=.FALSE.
      ICON=0
      LT5C=0
      LT8C=0
      IE=0
      IB=1
      PRMO=0.
      NCCD=0
      NCCM=0
      ID8C=0
      ID5C=0
      NP=0
      NP8=0
      NCSM=0
      NCWM=0
      NCSP=0
      NCWP=0
      DO 31 I=1,6
         NBD(I)=0
         NED(I)=0
         NBD8(I)=0
   31 NED8(I)=0
C
      WRITE (*,'(1X,A1\)') '1'
C*******************************************************************
C
C                       DATA INPUT ROUTINES
C
   61 IF(SWFI) GO TO 72
      TH=.FALSE.
C
      READ (3,18,END = 700, ERR = 13)NAME,KOUN,RLA1,RLA2,H,
     1RLO1,RLO2,EW,EL,
     2(MP(I),I=1,12),(T(I),I=1,12),
     3YE, ENGLMTRC, ORIG
   18 FORMAT(A16,A4,2I2,A1,2I2,A1,25F5.1,2I3,2A1)
      GO TO 62
   13 WRITE (*,'(1X,A14\)') 'ERROR IN INPUT'
      GO TO 61
C
C*******************************************************************
C
   62 WRITE (*,'(1X,A1\)') '>'
      IF ((ENGLMTRC.EQ.'M').OR.(ENGLMTRC.EQ.'m')) GO TO 21
      DO 20 I = 1, 12
         T(I) = (T(I)-32.) * (5./9.)
         MP(I) = MP(I) * 25.4
C         MPE(I) = MPE(I) * 25.4
   20    CONTINUE
      IF (EL.NE.-100.) EL = EL*0.305
   21 IF (H.EQ.'n') H = 'N'
      IF (H.EQ.'s') H = 'S'
C
C  DECIDE ON CALCULATION OF POTENTIAL EVAPOTRANSPIRATION
C
      WRITE (*,'(1X,A1\)') '2'
C
       TH=.TRUE.
C
C START PROCESSING
C
   72 CONTINUE
      IF(.NOT.TH) GO TO 331
      CALL WH04TH(T,RLA1,RLA2,MPE,H)
      WRITE (*,'(1X,A1\)') '3'
  331 ARF=0.
      AEV=0.
      DO 808 I = 1, 12
      ARF=ARF + MP(I)
  808 AEV= AEV + MPE(I)

      IYE=YE(1)
      NPR=NPR+1
      LSTN(NPR)=NPR
      WORD(NPR)=NAME
      SWFI=.FALSE.
      IF((NPR-1).EQ.0) GO TO 401
      IF(NAME.NE.KCHK)GO TO 601
C
C   BEGIN EXECUTION
C
  401 WRITE (*,'(1X,A1\)') '4'
      KCHK=NAME
C
C   PROCESS TEMPERATURE DATA
C
C      WRITE(*,84)FCD, T(1), T(12)
C   84 FORMAT(/,' FCD AND T1 AND T2 ARE:',3(F5.1,2X))
      CALL WH04T2(FC,FCD,T,H,CR,REG,TMA,ST,WT,DIF)
C      WRITE(*,83)TMA, ST, WT
C   83 FORMAT(/,' TEMP.DATA ARE:',3(F5.1,2X))
      DO 35 KF=1,6
         IF (REG(KF)) TRR=PREG(KF)
   35    CONTINUE
      DO 40 KF=7,10
         IF(REG(KF)) THEN
            KG=KF-4
            PPRF=IPRF(1)
            TRR=PREG(KG)
           ENDIF
   40    CONTINUE
C
C     CHECK IF PRECIPITATION ALWAYS EXCEEDS EVAPOTRANSPIRATION
C
      DO 45 JP=1,12
         IF (MPE(JP).GT.MP(JP)) GOTO 50
   45    CONTINUE
      CD(5)=.TRUE.
      SWT=.TRUE.
C
C PRELIMINARY PROCESSING
C
C   RUN 10 TIMES
   50 IF (NPR.GT.1)GO TO 59
      DO 65 N=1,10
C
C   TWELVE MONTHS
      DO 55 IM=1,12
      CALL WH04B1(IM)
      CALL WH04F2(IM)
      CALL WH04B1(IM)
   55 CONTINUE
C
C   EXIT FROM PRELIMINARY PROCESSING
C
      TMOI=0.
      DO 60 IT=1,64
   60 TMOI = TMOI + SL(IT)
      IF ( ABS(TMOI-PRMO).LE.( PRMO/100.)) GOTO 70
      PRMO=TMOI
   65 CONTINUE
C
C   EVALUATE MOISTURE CONDITION
C
   70 CALL WH04F3(K)
C
C DIAGNOSTIC  PROCESSING
C
   59 DO 80 IM=1,12
      CALL WH04F1(IM,K)
      CALL WH04F2(IM)
      CALL WH04F3(K)
      CALL WH04F1(IM,K)
   80 CONTINUE
C
C  PROCESS TEMPERATURE AND MOISTURE CALENDER
C
      SN=.FALSE.
      DO 85 I=1,12
      IF(T(I).LT.5.)GOTO 90
   85 CONTINUE
      GOTO 130
C
C  CALCULATIONS FOR DETERMINING SEASON ABOVE 5 DEGREES CELCIUS
C
C      AVOID T SEQUENCE =5.
C
   90 T13=T(1)
      DO 95 IT=1,11
      IF(T(IT).EQ.5..AND.T(IT+1).EQ.5.)T(IT)=5.01
   95 CONTINUE
      IF(T(12).EQ.5..AND.T13.EQ.5.)T(12)=5.01
C
      CALL WH04T1(5.,NBD,NED,T,NP)
      TC=.TRUE.
      IF(NP.EQ.0) GO TO 120
      DO 115 I=1,NP
      IB=NBD(I)
      IF(NBD(I).LT.NED(I)) GO TO 129
      IR=361-NBD(I)+NED(I)
      GO TO 105
  129 IR=NED(I)-NBD(I)+1
  105 CALL WH04F7(IB,IR,NZD)
      DO 110 IC=1,3
  110 NSD(IC)=NSD(IC)+NZD(IC)
      LT5C=LT5C+IR
  115 CONTINUE
      ID5C=NBD(1)
      GO TO 140
  120 IF(WT.GT.5.) GO TO 130
      LT5C=0
      NBD(1)=-1
      ID5C=0
      DO 125 IK=1,3
  125 NSD(IK)=0
      TC=.FALSE.
      GO TO 140
C
C  CALCULATIONS WHEN ALL TEMPERATURES ARE ABOVE 5 DEGREES
C
  130 TC=.FALSE.
      DO 135 IC=1,3
  135 NSD(IC)=ND(IC)
      LT5C=360
C  ORIGINAL SAID ID5C=BLAN !!!!!
      ID5C=0
C
C  CALCULATIONS
C
C  DEFINING SEASON ABOVE 8 DEGREES CELCIUS
C
  140 DO 145 IC=1,2
  145 NCPM(IC)=0
      DO 150 IC=1,12
      IF(T(IC).LT.8.) GO TO 155
  150 CONTINUE
      GO TO 190
C
C  DEFINE SEASON AND CALCULATE TIMES
C
C      AVOID T SEQUENCE = 8.
C
  155 T13=T(1)
      DO 160 IT=1,11
      IF(T(IT).EQ.8..AND.T(IT+1).EQ.8.) T(IT)=8.01
  160 CONTINUE
      IF(T(12).EQ.8..AND.T13.EQ.8.)T(12)=8.01
C
C
      CALL WH04T1(8.,NBD8,NED8,T,NP8)
      TC=.TRUE.
      IF (NP8.EQ.0) GO TO 185
      DO 175 I=1,NP8
      IB=NBD8(I)
      IF(NBD8(I).LT.NED8(I)) GO TO 165
      IR=361-NBD8(I)+NED8(I)
      GO TO 170
  165 IR=NED8(I)-NBD8(I)+1
  170 MSW=.FALSE.
      CALL WH04F5(IB,IR,1,ICON,IDAY,MSW)
      IF(NCPM(2).GT.ICON) GO TO 175
      NCPM(2)=ICON
      LT8C=IR
      ID8C=NBD8(I)
  175 CONTINUE
  180 SN=.TRUE.
      GOTO 195
  185 IF(WT.GT.8.) GO TO 190
      LT8C=0
      NBD8(1)=-1
      ID8C=0
      NCPM(2)=0
      MSW=.FALSE.
      GO TO 180
C
C  CALCULATIONS WHEN ALL TEMPERATURES ABOVE 8 DEGRESS
C
  190 MSW=.FALSE.
      TC=.FALSE.
      LT8C=360
      ID8C=0
  195 CALL WH04F5(1,720,1,ICON,IDAY,MSW)
      IF(ICON.GT.360)ICON=360
      NCPM(1)=ICON
      IF(SN)GOTO 200
      NCPM(2)=NCPM(1)
  200 SN=.FALSE.
C
C  CALCULATIONS FOR XERIC MOISTURE REGIME
C
      MSW=.TRUE.
      IF (H.EQ.HH(1)) THEN
         IB=181
         IC=1
        ELSE IF (H.EQ.HH(2)) THEN
         IB=1
         IC=181
        ENDIF
  205 CALL WH04F5(IB,120,1,NCCD,IDAY,MSW)
      CALL WH04F5(IC,120,3,NCCM,IDAY,MSW)
C
      IF(ND(3).EQ.360) GO TO 215
      IF(ND(1).EQ.360) GO TO 230
      IF (ND(1).EQ.0) GO TO 210
      TU=.FALSE.
      CALL WH04F5(IB,180,1,NCSM,IDAY,TU)
      CALL WH04F5(IC,180,1,NCWM,IDAY,TU)
      GO TO 220
  210 TU=.TRUE.
      CALL WH04F5(IB,180,3,NCSP,IDAY,TU)
      CALL WH04F5(IC,180,3,NCWP,IDAY,TU)
      GO TO 220
  215 NCSM=180
      NCWM=180
      NCSP=180
      NCWP=180
      NTSU(3)=180
      NTWI(3)=180
      GO TO 230
  220 CALL WH04F7(IB,180,NTSU)
      DO 225 I=1,3
  225 NTWI(I)=ND(I)-NTSU(I)
C
  230 IF (TC) CALL WH04T4(NTD,NBD,NED,NBD8,NED8)
C
C    TEST FOR SUBDIVISION OF USTIC MOISTURE REGIME
C
      CALL WH04F6(LT5C,LT8C,NSD,NCPM,NCCD,NCCM,REG,ND,
     1SWT,CD,TMA,DIF,ANS)
C
C   PRINT '.' TO INDICATE A STATION HAS BEEN PROCESSED
C
      WRITE (*,'(1X,A1\)') '.'
C
C  STORE, WRITE RESULTS ON TEMPORARY FILES 
C
      WRITE (*,'(1X,A1\)') '6'
      WRITE(7,58)NPR,NAME,TMA,ST,PPRF,TRR,ND,NSD,NCPM,NCCD,
     1NCCM,ANS,NCSM,NCWM,NCSP,NCWP,NTSU,NTWI,KOUN,WT,RLA1,
     2RLA2,RLO1,RLO2,LT5C,LT8C,TH
   58 FORMAT(I3,A16,2F5.1,A4,A8,10I3,A8,10I3,A4,F5.1,6I3,L1)  
C      IF(.NOT.OPT(3)) GO TO 451
      IF(ALT2.NE.YA) GO TO 451
      WRITE (*,'(1X,A1\)') '7'
      WRITE(9,66)IYE,IDAY,ANS
   66 FORMAT(I4,360I1,A8)
C
  451 CONTINUE
      CALL CPRO(NSD,LT5C,NCPM,NCCD,NCCM,NPR,PT,IYE,TYE,CD)
      PT(NPR,32)=SWT
      GO TO 100
  700 SWST=.TRUE.
      NPR=NPR+1
C
C PROBABILITY SUMMARY
C
  601 WRITE (*,'(1X,A1\)') 'E'
      REWIND(7)
      REWIND(9)
      SWFI=.TRUE.
      NPR=NPR-1
C     IF(.NOT.OPT(2))GO TO 602
C      IF(ALT2(1).NE.YA)GO TO 602
      CALL CPSU (PT,NPR,LSTN,IND,TD,WTC,FC,FCD,TYE,KCHK,ANS)
C  602 CONTINUE
C      IF(.NOT.OPT(3))GO TO 104
      IF(ALT2.NE.YA)GO TO 104
      CALL CALE(KCHK,TD,NPR,ANS)
  104 CONTINUE
      NPR=0
      K=1
      DO 77 N=1,64
   77 SL(N)=0.
      KCHK=NAME
      DO 761 I=1,30
      DO 761 J=1,41
  761 PT(I,J)=.FALSE.
      WORD(1)=NAME
      IF(SWST) GO TO 998
      GO TO 100
  998 CONTINUE
      CLOSE (8, STATUS = 'KEEP')
      CLOSE (7, STATUS = 'KEEP')
      CLOSE (9, STATUS = 'KEEP')
      WRITE (*,98)
   98 FORMAT(///'         DO YOU WANT A PRINTOUT OF THE EXPLANATIONS',/
     1'          OF THE COLUMNS IN THE FREQUENCY TABLE?',//
     7' ANSWER BY TYPING Y OR N AND PRESSING ENTER :')
      READ(*,181)ALT3
  181 FORMAT(BN,A1)
      IF(ALT3.NE.YA) GO TO 182
      CALL CUEXPL
  182 STOP
      END
